import React from 'react';
import { Theme } from '@material-ui/core';
import { ClassKeyOfStyles, ClassNameMap, Styles } from '@material-ui/styles/withStyles';
import './print.css';
declare type ReportStyles = "root" | "page" | "backBtn" | "btnContainer" | "table" | "tableScroll" | "rowRoot" | "headerCell1" | "headerCell2" | "cellClickable" | "cellHiddenPrint" | "cellCode" | "cellNumber" | "@media screen" | "@media print";
export declare type ReportClasses = ClassNameMap<ClassKeyOfStyles<Styles<Theme, {}, ReportStyles>>>;
interface FilterEditorProps {
    value: any;
    handleChange: ((e: any) => void);
    label: string;
}
interface FilterField {
    key: string;
    label: string;
    mandatory: boolean;
    advanced?: boolean;
    source: 'auth' | 'app';
    editor?: {
        EditorComponent: React.FunctionComponent<FilterEditorProps>;
    };
}
interface TableProps {
    queryParams: any;
    data: any[];
    classes: ReportClasses;
}
interface HeaderProps {
    queryParams: any;
    classes: ReportClasses;
}
interface IProps {
    query: string;
    title: string;
    filterKeys: string[];
    filters: FilterField[];
    TableComponent: React.FunctionComponent<TableProps>;
    HeaderComponent: React.FunctionComponent<HeaderProps>;
}
declare const _default: React.FunctionComponent<IProps>;
export default _default;
export declare const makeReportUrl: (baseUser: string, filterKeys: string[], argParams: any, queryParams: any) => string;
