import { useEffect, useContext } from 'react';
import { useHistory } from 'react-router';
import { parseSearch } from '../utils/generalUtils';
import { AppStoreContext } from '../store/appStore';
export var useSetFilter = function (filterKeys) {
    var history = useHistory();
    var appStore = useContext(AppStoreContext);
    var search = history.location.search;
    useEffect(function () {
        var params = parseSearch(search);
        filterKeys.forEach(function (k) {
            var pv = params[k] || null;
            var v;
            if (pv && pv.startsWith('{') && pv.endsWith('}')) {
                v = pv.substring(1, pv.length - 1).split(',').filter(function (v) { return !!v; });
            }
            else {
                v = pv;
            }
            appStore.setFilter(k, v);
        });
        // if(filters){
        //   const addingParams = filters.filter( f => params.findIndex( p => p.key === f ) === -1)
        //     .map( f => ({key: f, value : appStore.getFilter(f)}))
        //     .filter( f => !!f.value).map( f => `${f.key}=${f.value}`);
        //   if(addingParams.length > 0){
        //     const {pathname, hash, search} = history.location;
        //     const url = pathname + ((search ? search + '&' : '?') + addingParams.join('&')) + hash;
        //     history.replace(url);
        //   }
        // }
    }, [search, appStore, filterKeys]);
};
