var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { observable, decorate, action, configure } from 'mobx';
import { createContext } from 'react';
// import { setAppStore } from '../api/kamandApi';
import { fetchData, loadActData, saveActData, removeActData } from '../api/kamandApi';
import { hash } from '../utils/generalUtils';
import { connectWebSocketToServer, doAsyncActData, listenAsyncActData } from '../api/kamandSocket';
configure({ enforceActions: "observed" });
var AppStore = /** @class */ (function () {
    function AppStore() {
        this.pageTitle = '';
        this.appBarHidden = false;
        this.queryData = observable.map({}, { deep: false });
        this.filtersData = observable.map({});
        this.actData = observable.map({}, { deep: false });
        this.optionData = observable.map({}, { deep: false });
        this.loadingActData = {};
        connectWebSocketToServer();
        // setAppStore(this);
    }
    AppStore.prototype.setPageTitle = function (pageTitle) {
        this.pageTitle = pageTitle;
    };
    AppStore.prototype.hideAppBar = function (appBarHidden) {
        this.appBarHidden = appBarHidden;
    };
    AppStore.prototype.setSnackMessage = function (snackMessage) {
        this.snackMessage = snackMessage;
    };
    AppStore.prototype.setFilter = function (key, filter) {
        this.filtersData.set(key, filter);
    };
    AppStore.prototype.getFilter = function (key) {
        return this.filtersData.get(key);
    };
    AppStore.prototype.setQueryData = function (key, queryParam, data, loading, error) {
        if (Array.isArray(data)) {
            data.forEach(function (d, i) {
                d.arrayIndex = i;
            });
        }
        var qd = observable.object({
            queryParam: observable.map(queryParam, { deep: false }),
            data: !data ? [] : observable.array(data, { deep: false }),
            loading: loading,
            error: error,
        }, {});
        this.queryData.set(key, qd);
    };
    AppStore.prototype.getQueryData = function (key) {
        return this.queryData.get(key);
    };
    AppStore.prototype.invalidateQueryDataCache = function (key) {
        return this.queryData.delete(key);
    };
    AppStore.prototype.prepareQueryData = function (key, query, queryParam, forceRefresh, publicQuery, makeupData) {
        if (publicQuery === void 0) { publicQuery = true; }
        return __awaiter(this, void 0, void 0, function () {
            var previousData, data, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(!this.queryData.has(key) || forceRefresh)) return [3 /*break*/, 4];
                        previousData = this.getQueryData(key);
                        if (previousData) {
                            this.setQueryData(key, queryParam, previousData.data, true, false);
                        }
                        else {
                            this.setQueryData(key, queryParam, undefined, true, false);
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, fetchData(query, queryParam, publicQuery)];
                    case 2:
                        data = _a.sent();
                        if (makeupData)
                            data = makeupData(data);
                        this.setQueryData(key, queryParam, data, false, !data);
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        console.error("error while fetching data in prepareQueryData with " + err_1);
                        this.setQueryData(key, queryParam, undefined, false, true);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    AppStore.prototype.setActData = function (key, actData) {
        this.actData.set(key, actData);
    };
    AppStore.prototype.getActData = function (key) {
        return this.actData.get(key);
    };
    AppStore.prototype.deleteActData = function (key) {
        return this.actData.delete(key);
    };
    AppStore.prototype.loadActDataFirstCache = function (key, query, queryParam, makeObservable) {
        return __awaiter(this, void 0, void 0, function () {
            var cache, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cache = this.actData.get(key);
                        if (cache)
                            return [2 /*return*/, cache];
                        return [4 /*yield*/, this.loadActData(key, query, queryParam, makeObservable)];
                    case 1:
                        data = _a.sent();
                        return [2 /*return*/, data];
                }
            });
        });
    };
    AppStore.prototype.loadActData = function (key, query, queryParam, makeObservable) {
        return __awaiter(this, void 0, void 0, function () {
            var hashKey, data, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        hashKey = query + '/' + hash(JSON.stringify(queryParam));
                        if (this.loadingActData[hashKey])
                            return [2 /*return*/];
                        this.loadingActData[hashKey] = true;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, 4, 5]);
                        return [4 /*yield*/, loadActData(query, queryParam)];
                    case 2:
                        data = _a.sent();
                        if (data) {
                            if (makeObservable) {
                                this.setActData(key, makeObservable(data));
                            }
                            else {
                                this.setActData(key, data);
                            }
                        }
                        return [2 /*return*/, data];
                    case 3:
                        err_2 = _a.sent();
                        throw err_2;
                    case 4:
                        delete this.loadingActData[hashKey];
                        return [7 /*endfinally*/];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    AppStore.prototype.saveActData = function (key, query, data) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (key)
                            this.setActData(key, data);
                        return [4 /*yield*/, saveActData(query, data)];
                    case 1:
                        result = _a.sent();
                        if (result && key) {
                            this.setActData(key, result);
                        }
                        return [2 /*return*/, result];
                }
            });
        });
    };
    AppStore.prototype.removeActData = function (key, query, data) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, removeActData(query, data)];
                    case 1:
                        result = _a.sent();
                        if (result && key) {
                            this.deleteActData(key);
                        }
                        return [2 /*return*/, result];
                }
            });
        });
    };
    AppStore.prototype.doAsyncActData = function (query, data) {
        doAsyncActData(query, data);
    };
    AppStore.prototype.listenAsyncActData = function (event, callback) {
        listenAsyncActData(event, callback);
    };
    AppStore.prototype.setOptionData = function (key, data) {
        this.optionData.set(key, data);
    };
    AppStore.prototype.getOptionData = function (key) {
        return this.optionData.get(key);
    };
    return AppStore;
}());
export { AppStore };
decorate(AppStore, {
    pageTitle: observable,
    setPageTitle: action,
    appBarHidden: observable,
    hideAppBar: action,
    snackMessage: observable,
    setSnackMessage: action,
    setFilter: action,
    setQueryData: action,
    invalidateQueryDataCache: action,
    prepareQueryData: action,
    setActData: action,
    loadActDataFirstCache: action,
    loadActData: action,
    saveActData: action,
    removeActData: action,
    setOptionData: action,
});
export var appStore = new AppStore();
export var AppStoreContext = createContext(appStore);
